]> git.saurik.com Git - apt.git/blame_incremental - test/integration/framework
merged from donkult
[apt.git] / test / integration / framework
... / ...
CommitLineData
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
5 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
6 CERROR="\e[1;31m" # red
7 CWARNING="\e[1;33m" # yellow
8 CMSG="\e[1;32m" # green
9 CINFO="\e[1;96m" # light blue
10 CDEBUG="\e[1;94m" # blue
11 CNORMAL="\e[0;39m" # default system console color
12 CDONE="\e[1;32m" # green
13 CPASS="\e[1;32m" # green
14 CFAIL="\e[1;31m" # red
15 CCMD="\e[1;35m" # pink
16fi
17
18msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
21msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
28msgtest() {
29 while [ -n "$1" ]; do
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
32 shift
33 if [ -n "$1" ]; then shift; else break; fi
34 done
35 echo -n "…${CNORMAL} " >&2;
36}
37msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
40
41# enable / disable Debugging
42MSGLEVEL=${MSGLEVEL:-3}
43if [ $MSGLEVEL -le 0 ]; then
44 msgdie() { true; }
45fi
46if [ $MSGLEVEL -le 1 ]; then
47 msgwarn() { true; }
48 msgnwarn() { true; }
49fi
50if [ $MSGLEVEL -le 2 ]; then
51 msgmsg() { true; }
52 msgnmsg() { true; }
53 msgtest() { true; }
54 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
56 if [ -n "$CFAIL" ]; then
57 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
58 else
59 msgfail() { echo -n " ###FAILED###" >&2; }
60 fi
61fi
62if [ $MSGLEVEL -le 3 ]; then
63 msginfo() { true; }
64 msgninfo() { true; }
65fi
66if [ $MSGLEVEL -le 4 ]; then
67 msgdebug() { true; }
68 msgndebug() { true; }
69fi
70msgdone() {
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
76 true;
77 else
78 echo "${CDONE}DONE${CNORMAL}" >&2;
79 fi
80}
81
82runapt() {
83 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
84 if [ -f ./aptconfig.conf ]; then
85 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
86 elif [ -f ../aptconfig.conf ]; then
87 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
88 else
89 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
90 fi
91}
92aptconfig() { runapt apt-config $*; }
93aptcache() { runapt apt-cache $*; }
94aptget() { runapt apt-get $*; }
95aptftparchive() { runapt apt-ftparchive $*; }
96aptkey() { runapt apt-key $*; }
97aptmark() { runapt apt-mark $*; }
98dpkg() {
99 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
100}
101aptitude() {
102 if [ -f ./aptconfig.conf ]; then
103 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
104 elif [ -f ../aptconfig.conf ]; then
105 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
106 else
107 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
108 fi
109}
110gdb() {
111 echo "gdb: run »$*«"
112 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
113}
114
115addtrap() {
116 CURRENTTRAP="$CURRENTTRAP $1"
117 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
118}
119
120setupenvironment() {
121 TMPWORKINGDIRECTORY=$(mktemp -d)
122 TESTDIRECTORY=$(readlink -f $(dirname $0))
123 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
124 BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
125 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
126 local OLDWORKINGDIRECTORY=$(pwd)
127 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
128 cd $TMPWORKINGDIRECTORY
129 mkdir rootdir aptarchive keys
130 cd rootdir
131 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
132 mkdir -p var/cache var/lib var/log
133 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
134 touch var/lib/dpkg/available
135 mkdir -p usr/lib/apt
136 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
137 cd ..
138 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
139 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
140 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
141 fi
142 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
143 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
144 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
145 fi
146 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
147 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
148 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
149 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
150 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
151 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
152 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
153 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
154 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
155 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
158 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
159 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
160 fi
161 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
162 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
163 export LC_ALL=C
164 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
165 msgdone "info"
166}
167
168getarchitecture() {
169 if [ "$1" = "native" -o -z "$1" ]; then
170 eval `aptconfig shell ARCH APT::Architecture`
171 if [ -n "$ARCH" ]; then
172 echo $ARCH
173 else
174 dpkg --print-architecture
175 fi
176 else
177 echo $1
178 fi
179}
180
181getarchitectures() {
182 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
183}
184
185configarchitecture() {
186 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
187 rm -f $CONFFILE
188 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
189 shift
190 while [ -n "$1" ]; do
191 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
192 shift
193 done
194 configdpkg
195}
196
197configdpkg() {
198 if [ ! -e rootdir/var/lib/dpkg/status ]; then
199 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
200 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
201 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
202 else
203 echo -n > rootdir/var/lib/dpkg/status
204 fi
205 fi
206 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
207 local ARCHS="$(getarchitectures)"
208 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
209 DPKGARCH="$(dpkg --print-architecture)"
210 for ARCH in ${ARCHS}; do
211 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
212 done
213 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
214 # dpkg doesn't really check the version as long as it is fully installed,
215 # but just to be sure we choose one above the required version
216 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
217 fi
218 fi
219 fi
220}
221
222setupsimplenativepackage() {
223 local NAME="$1"
224 local ARCH="$2"
225 local VERSION="$3"
226 local RELEASE="${4:-unstable}"
227 local DEPENDENCIES="$5"
228 local DESCRIPTION="$6"
229 local SECTION="${7:-others}"
230 local DISTSECTION
231 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
232 DISTSECTION="main"
233 else
234 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
235 fi
236 local BUILDDIR=incoming/${NAME}-${VERSION}
237 mkdir -p ${BUILDDIR}/debian/source
238 cd ${BUILDDIR}
239 echo "* most suckless software product ever" > FEATURES
240 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
241 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
242
243 * Initial release
244
245 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
246 test -e debian/control || echo "Source: $NAME
247Section: $SECTION
248Priority: optional
249Maintainer: Joe Sixpack <joe@example.org>
250Build-Depends: debhelper (>= 7)
251Standards-Version: 3.9.1
252
253Package: $NAME" > debian/control
254 if [ "$ARCH" = 'all' ]; then
255 echo "Architecture: all" >> debian/control
256 else
257 echo "Architecture: any" >> debian/control
258 fi
259 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
260 if [ -z "$DESCRIPTION" ]; then
261 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
262 If you find such a package installed on your system,
263 YOU did something horribly wrong! They are autogenerated
264 und used only by testcases for APT and surf no other propose…" >> debian/control
265 else
266 echo "Description: $DESCRIPTION" >> debian/control
267 fi
268 test -e debian/compat || echo "7" > debian/compat
269 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
270 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
271 cd - > /dev/null
272}
273
274buildsimplenativepackage() {
275 local NAME="$1"
276 local ARCH="$2"
277 local VERSION="$3"
278 local RELEASE="${4:-unstable}"
279 local DEPENDENCIES="$5"
280 local DESCRIPTION="$6"
281 local SECTION="${7:-others}"
282 local PRIORITY="${8:-optional}"
283 local DISTSECTION
284 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
285 DISTSECTION="main"
286 else
287 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
288 fi
289 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
290
291 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
292 mkdir -p $BUILDDIR/debian/source
293 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
294 echo "#!/bin/sh
295echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
296
297 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
298 echo "$NAME ($VERSION) $RELEASE; urgency=low
299
300 * Initial release
301
302 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
303 echo "Source: $NAME
304Section: $SECTION
305Priority: $PRIORITY
306Maintainer: Joe Sixpack <joe@example.org>
307Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
308 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
309 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
310 echo "
311Package: $NAME" >> ${BUILDDIR}/debian/control
312
313 if [ "$ARCH" = 'all' ]; then
314 echo "Architecture: all" >> ${BUILDDIR}/debian/control
315 else
316 echo "Architecture: any" >> ${BUILDDIR}/debian/control
317 fi
318 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
319 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
320 if [ -z "$DESCRIPTION" ]; then
321 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
322 If you find such a package installed on your system,
323 YOU did something horribly wrong! They are autogenerated
324 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
325 else
326 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
327 fi
328
329 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
330 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
331 for SRC in $SRCS; do
332 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
333 done
334
335 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
336 rm -rf ${BUILDDIR}/debian/tmp
337 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
338 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
339 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
340 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
341 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
342
343 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
344 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
345 done
346
347 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
348 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
349 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
350 rm -rf "${BUILDDIR}"
351 msgdone "info"
352}
353
354buildpackage() {
355 local BUILDDIR=$1
356 local RELEASE=$2
357 local SECTION=$3
358 local ARCH=$(getarchitecture $4)
359 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
360 cd $BUILDDIR
361 if [ "$ARCH" = "all" ]; then
362 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
363 fi
364 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
365 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
366 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
367 cd - > /dev/null
368 for PKG in $PKGS; do
369 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
370 done
371 for SRC in $SRCS; do
372 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
373 done
374 msgdone "info"
375}
376
377buildaptarchive() {
378 if [ -d incoming ]; then
379 buildaptarchivefromincoming $*
380 else
381 buildaptarchivefromfiles $*
382 fi
383}
384
385createaptftparchiveconfig() {
386 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
387 if [ -z "$ARCHS" ]; then
388 # the pool is empty, so we will operate on faked packages - let us use the configured archs
389 ARCHS="$(getarchitectures)"
390 fi
391 echo -n 'Dir {
392 ArchiveDir "' >> ftparchive.conf
393 echo -n $(readlink -f .) >> ftparchive.conf
394 echo -n '";
395 CacheDir "' >> ftparchive.conf
396 echo -n $(readlink -f ..) >> ftparchive.conf
397 echo -n '";
398 FileListDir "' >> ftparchive.conf
399 echo -n $(readlink -f pool/) >> ftparchive.conf
400 echo -n '";
401};
402Default {
403 Packages::Compress ". gzip bzip2 lzma xz";
404 Sources::Compress ". gzip bzip2 lzma xz";
405 Contents::Compress ". gzip bzip2 lzma xz";
406 Translation::Compress ". gzip bzip2 lzma xz";
407 LongDescription "false";
408};
409TreeDefault {
410 Directory "pool/";
411 SrcDirectory "pool/";
412};
413APT {
414 FTPArchive {
415 Release {
416 Origin "joesixpack";
417 Label "apttestcases";
418 Suite "unstable";
419 Description "repository with dummy packages";
420 Architectures "' >> ftparchive.conf
421 echo -n "$ARCHS" >> ftparchive.conf
422 echo 'source";
423 };
424 };
425};' >> ftparchive.conf
426 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
427 echo -n 'tree "dists/' >> ftparchive.conf
428 echo -n "$DIST" >> ftparchive.conf
429 echo -n '" {
430 Architectures "' >> ftparchive.conf
431 echo -n "$ARCHS" >> ftparchive.conf
432 echo -n 'source";
433 FileList "' >> ftparchive.conf
434 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
435 echo -n '";
436 SourceFileList "' >> ftparchive.conf
437 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
438 echo -n '";
439 Sections "' >> ftparchive.conf
440 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
441 echo '";
442};' >> ftparchive.conf
443 done
444}
445
446buildaptftparchivedirectorystructure() {
447 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
448 for DIST in $DISTS; do
449 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
450 for SECTION in $SECTIONS; do
451 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
452 for ARCH in $ARCHS; do
453 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
454 done
455 mkdir -p dists/${DIST}/${SECTION}/source
456 mkdir -p dists/${DIST}/${SECTION}/i18n
457 done
458 done
459}
460
461insertpackage() {
462 local RELEASE="$1"
463 local NAME="$2"
464 local ARCH="$3"
465 local VERSION="$4"
466 local DEPENDENCIES="$5"
467 local PRIORITY="${6:-optional}"
468 local ARCHS=""
469 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
470 if [ "$arch" = "all" ]; then
471 ARCHS="$(getarchitectures)"
472 else
473 ARCHS="$arch"
474 fi
475 for BUILDARCH in $ARCHS; do
476 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
477 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
478 touch aptarchive/dists/${RELEASE}/main/source/Sources
479 local FILE="${PPATH}/Packages"
480 echo "Package: $NAME
481Priority: $PRIORITY
482Section: other
483Installed-Size: 42
484Maintainer: Joe Sixpack <joe@example.org>
485Architecture: $arch
486Version: $VERSION
487Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
488 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
489 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
490 If you find such a package installed on your system,
491 YOU did something horribly wrong! They are autogenerated
492 und used only by testcases for APT and surf no other propose…
493" >> $FILE
494 done
495 done
496}
497
498insertsource() {
499 local RELEASE="$1"
500 local NAME="$2"
501 local ARCH="$3"
502 local VERSION="$4"
503 local DEPENDENCIES="$5"
504 local ARCHS=""
505 local SPATH="aptarchive/dists/${RELEASE}/main/source"
506 mkdir -p $SPATH
507 local FILE="${SPATH}/Sources"
508 echo "Package: $NAME
509Binary: $NAME
510Version: $VERSION
511Maintainer: Joe Sixpack <joe@example.org>
512Architecture: $ARCH" >> $FILE
513 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
514 echo "Files:
515 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
516 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
517" >> $FILE
518}
519
520insertinstalledpackage() {
521 local NAME="$1"
522 local ARCH="$2"
523 local VERSION="$3"
524 local DEPENDENCIES="$4"
525 local PRIORITY="${5:-optional}"
526 local FILE='rootdir/var/lib/dpkg/status'
527 local INFO='rootdir/var/lib/dpkg/info'
528 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
529 echo "Package: $NAME
530Status: install ok installed
531Priority: $PRIORITY
532Section: other
533Installed-Size: 42
534Maintainer: Joe Sixpack <joe@example.org>
535Architecture: $arch
536Version: $VERSION" >> $FILE
537 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
538 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
539 If you find such a package installed on your system,
540 YOU did something horribly wrong! They are autogenerated
541 und used only by testcases for APT and surf no other propose…
542" >> $FILE
543 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
544 echo -n > ${INFO}/${NAME}:${arch}.list
545 else
546 echo -n > ${INFO}/${NAME}.list
547 fi
548 done
549}
550
551
552buildaptarchivefromincoming() {
553 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
554 cd aptarchive
555 [ -e pool ] || ln -s ../incoming pool
556 [ -e ftparchive.conf ] || createaptftparchiveconfig
557 [ -e dists ] || buildaptftparchivedirectorystructure
558 msgninfo "\tGenerate Packages, Sources and Contents files… "
559 aptftparchive -qq generate ftparchive.conf
560 cd - > /dev/null
561 msgdone "info"
562 generatereleasefiles
563}
564
565buildaptarchivefromfiles() {
566 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
567 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
568 msgninfo "\t${line} file… "
569 cat ${line} | gzip > ${line}.gz
570 cat ${line} | bzip2 > ${line}.bz2
571 cat ${line} | xz --format=lzma > ${line}.lzma
572 cat ${line} | xz > ${line}.xz
573 msgdone "info"
574 done
575 generatereleasefiles
576}
577
578# can be overridden by testcases for their pleasure
579getcodenamefromsuite() { echo -n "$1"; }
580getreleaseversionfromsuite() { true; }
581getlabelfromsuite() { true; }
582
583generatereleasefiles() {
584 # $1 is the Date header and $2 is the ValidUntil header to be set
585 # both should be given in notation date/touch can understand
586 msgninfo "\tGenerate Release files… "
587 if [ -e aptarchive/dists ]; then
588 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
589 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
590 local CODENAME="$(getcodenamefromsuite $SUITE)"
591 local VERSION="$(getreleaseversionfromsuite $SUITE)"
592 local LABEL="$(getlabelfromsuite $SUITE)"
593 if [ -n "$VERSION" ]; then
594 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
595 fi
596 if [ -n "$LABEL" ]; then
597 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
598 fi
599 aptftparchive -qq release $dir \
600 -o APT::FTPArchive::Release::Suite="${SUITE}" \
601 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
602 ${LABEL} \
603 ${VERSION} \
604 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
605 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
606 sed -i '/^Date: / a\
607NotAutomatic: yes' $dir/Release
608 fi
609 if [ -n "$1" -a "$1" != "now" ]; then
610 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
611 fi
612 if [ -n "$2" ]; then
613 sed -i "/^Date: / a\
614Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
615 fi
616 done
617 else
618 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
619 fi
620 if [ -n "$1" -a "$1" != "now" ]; then
621 for release in $(find ./aptarchive -name 'Release'); do
622 touch -d "$1" $release
623 done
624 fi
625 msgdone "info"
626}
627
628setupdistsaptarchive() {
629 local APTARCHIVE=$(readlink -f ./aptarchive)
630 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
631 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
632 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
633 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
634 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
635 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
636 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
637 msgdone "info"
638 done
639}
640
641setupflataptarchive() {
642 local APTARCHIVE=$(readlink -f ./aptarchive)
643 if [ -f ${APTARCHIVE}/Packages ]; then
644 msgninfo "\tadd deb sources.list line… "
645 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
646 msgdone "info"
647 else
648 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
649 fi
650 if [ -f ${APTARCHIVE}/Sources ]; then
651 msgninfo "\tadd deb-src sources.list line… "
652 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
653 msgdone "info"
654 else
655 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
656 fi
657}
658
659setupaptarchive() {
660 buildaptarchive
661 if [ -e aptarchive/dists ]; then
662 setupdistsaptarchive
663 else
664 setupflataptarchive
665 fi
666 signreleasefiles
667 msgninfo "\tSync APT's cache with the archive… "
668 aptget update -qq
669 msgdone "info"
670}
671
672signreleasefiles() {
673 local SIGNER="${1:-Joe Sixpack}"
674 msgninfo "\tSign archive with $SIGNER key… "
675 local SECKEYS=""
676 for KEY in $(find keys/ -name '*.sec'); do
677 SECKEYS="$SECKEYS --secret-keyring $KEY"
678 done
679 local PUBKEYS=""
680 for KEY in $(find keys/ -name '*.pub'); do
681 PUBKEYS="$PUBKEYS --keyring $KEY"
682 done
683 for RELEASE in $(find aptarchive/ -name Release); do
684 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
685 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
686 done
687 msgdone "info"
688}
689
690changetowebserver() {
691 if which weborf > /dev/null; then
692 weborf -xb aptarchive/ 2>&1 > /dev/null &
693 addtrap "kill $!;"
694 elif which gatling > /dev/null; then
695 cd aptarchive
696 gatling -p 8080 -F -S 2>&1 > /dev/null &
697 addtrap "kill $!;"
698 cd - > /dev/null
699 elif which lighttpd > /dev/null; then
700 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
701server.port = 8080
702server.stat-cache-engine = \"disable\"" > lighttpd.conf
703 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
704 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
705 addtrap "kill $!;"
706 else
707 msgdie 'You have to install weborf or lighttpd first'
708 return 1
709 fi
710 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
711 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
712 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
713 done
714 return 0
715}
716
717checkdiff() {
718 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
719 if [ -n "$DIFFTEXT" ]; then
720 echo
721 echo "$DIFFTEXT"
722 return 1
723 else
724 return 0
725 fi
726}
727
728testfileequal() {
729 local FILE="$1"
730 shift
731 msgtest "Test for correctness of file" "$FILE"
732 if [ -z "$*" ]; then
733 echo -n "" | checkdiff $FILE - && msgpass || msgfail
734 else
735 echo "$*" | checkdiff $FILE - && msgpass || msgfail
736 fi
737}
738
739testequal() {
740 local COMPAREFILE=$(mktemp)
741 addtrap "rm $COMPAREFILE;"
742 echo "$1" > $COMPAREFILE
743 shift
744 msgtest "Test for equality of" "$*"
745 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
746}
747
748testequalor2() {
749 local COMPAREFILE1=$(mktemp)
750 local COMPAREFILE2=$(mktemp)
751 local COMPAREAGAINST=$(mktemp)
752 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
753 echo "$1" > $COMPAREFILE1
754 echo "$2" > $COMPAREFILE2
755 shift 2
756 msgtest "Test for equality OR of" "$*"
757 $* 2>&1 1> $COMPAREAGAINST
758 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
759 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
760 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
761 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
762 msgfail )
763}
764
765testshowvirtual() {
766 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
767 local PACKAGE="$1"
768 shift
769 while [ -n "$1" ]; do
770 VIRTUAL="${VIRTUAL}
771N: Can't select versions from package '$1' as it is purely virtual"
772 PACKAGE="${PACKAGE} $1"
773 shift
774 done
775 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
776 VIRTUAL="${VIRTUAL}
777N: No packages found"
778 local COMPAREFILE=$(mktemp)
779 addtrap "rm $COMPAREFILE;"
780 local ARCH="$(getarchitecture 'native')"
781 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
782 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
783}
784
785testnopackage() {
786 msgtest "Test for non-existent packages" "apt-cache show $*"
787 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
788 if [ -n "$SHOWPKG" ]; then
789 echo
790 echo "$SHOWPKG"
791 msgfail
792 return 1
793 fi
794 msgpass
795}
796
797testdpkginstalled() {
798 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
799 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
800 if [ "$PKGS" != $# ]; then
801 echo $PKGS
802 dpkg -l $* | grep '^[a-z]'
803 msgfail
804 return 1
805 fi
806 msgpass
807}
808
809testdpkgnotinstalled() {
810 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
811 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
812 if [ "$PKGS" != 0 ]; then
813 echo
814 dpkg -l $* | grep '^[a-z]'
815 msgfail
816 return 1
817 fi
818 msgpass
819}
820
821testmarkedauto() {
822 local COMPAREFILE=$(mktemp)
823 addtrap "rm $COMPAREFILE;"
824 if [ -n "$1" ]; then
825 msgtest 'Test for correctly marked as auto-installed' "$*"
826 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
827 else
828 msgtest 'Test for correctly marked as auto-installed' 'no package'
829 echo -n > $COMPAREFILE
830 fi
831 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
832}
833
834pause() {
835 echo "STOPPED execution. Press enter to continue"
836 local IGNORE
837 read IGNORE
838}